<?php
/*
Plugin Name: Wordpress Plurk Bot
Plugin URI: http://coffebreak.info
Description: Post your blog updates on your Plurk account
Version: 1.0
Author: Andon Ivanov
Author URI: http://coffebreak.info
*/


if(get_option('pb_username') == "")
{
	add_action('admin_notices', 'pb_warning');
}

add_action('admin_menu', 'plurkbot_menu');
add_action('publish_post', 'plurkbot_post');
add_action('save_post', 'pb_save_post_meta');
add_action('edit_form_advanced', 'pb_show_post_option');


function pb_warning()
{
	echo "<div class=\"error\"><p>Please update your <a href=\"".get_bloginfo('wpurl')."/wp-admin/options-general.php?page=plurkbot/plurkbot.php\">Plurkbot username and password</a>.</p></div>";
}

function plurkbot_menu() {
  add_options_page('Plurkbot Options', 'Plurkbot Options', 8, __FILE__, 'plurkbot_options');
}

function plurkbot_options() {

?>
<div class="wrap">
<h2>Plurkbot Options</h2>
<form method="post" action="options.php">

<?php wp_nonce_field('update-options'); ?>
<h3>About Plurk Wordpress Plugin</h3>
<p>With this plugin you can add messages to your Plurk profile when you add or modify your posts. This would help to notify your friends when you have new articles in your blog. This plugin is still under testing and will be glad to notify us if you find any problem. You can contact us at <a href="http://coffebreak.info" target="_blank">http://coffebreak.info</a>.</p>
<p>Best regards,<br />
Andon Ivanov</p>

<h3>Username and Password</h3>

<p>Enter your Plurk username and password to enable Plurkbot to post updates. If you don`t have Plurk account, you can <a href="http://www.plurk.com/Users/showRegister" target="_blank">Get one for free here.</a></p>

<table class="form-table">
<tr valign="top">
<th scope="row">Plurk Username</th>
<td><input type="text" name="pb_username" value="<?php echo get_option('pb_username'); ?>" /></td>
</tr>

<tr valign="top">
<th scope="row">Plurk Password</th>
<td><input type="password" name="pb_pw" value="<?php echo get_option('pb_pw'); ?>" /></td>
</tr>

</table>

<h3>Plurk prefix options.</h3>

<p>You can add prefix for new or updated blog posts, if you want.</p>
<table class="form-table">
<tr valign="top">
<th scope="row">Prefix for new blog posts:</th>
<td><input type="text" name="pb_new_prefix" size="40" value="<?php echo get_option('pb_new_prefix'); ?>" /></td>
</tr>

<tr valign="top">
<th scope="row">Prefix for updated blog posts:</th>
<td><input type="text" name="pb_update_prefix" size="40" value="<?php echo get_option('pb_update_prefix'); ?>" /></td>
</tr>

</table>

<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="pb_username,pb_pw,pb_new_prefix,pb_update_prefix" />

<p class="submit">
<input type="submit" name="Submit" value="<?php _e('Save Changes') ?>" />
</p>

</form>
</div>

<?php
}

function pb_save_post_meta($pid)
{
	if($_POST['do_pb_post'] != "")
	{
		update_pb_meta($pid, $_POST['do_pb_post']);
	}
}

function pb_show_post_option()
{
global $post;

	$notify = get_post_meta($post->ID, 'pb_plurk', true);

	echo "<div id=\"pb_plurkbot\" class=\"postbox\">";
	echo "<h3 class=\"hndle\"><span>Wordpress Plurkbot</span></h3>";
	echo "<div class=\"inside\">Plurk this post to Plurk? ";

	echo "<input id=\"skip_pb_post\" type=\"radio\" name=\"do_pb_post\" value=\"yes\"";
	if($notify == "yes" || $notify == "")
	{
		echo " checked=\"checked\"";
	}
	echo " /> <label for=\"skip_pb_post\">Yes</label> ";


	echo "<input id=\"do_pb_post\" type=\"radio\" name=\"do_pb_post\" value=\"no\"";

	if($notify == "no")
	{
		echo " checked=\"checked\"";
	}

	echo " /> <label for=\"do_pb_post\">No</label>";

	echo "</div>";
	echo "</div>";
}


function plurkbot_post($pid)
{

	if($_POST['action'] != "autosave" and $_POST['post_status'] != "draft") 
	{

		$username = get_option('pb_username');
		$password = get_option('pb_pw');

		$title = get_the_title($pid);
		$postlink = get_permalink($pid);

		if($_POST['do_pb_post'] == "")
		{
			$_POST['do_pb_post'] == "yes";
		}

		update_pb_meta($pid, $_POST['do_pb_post']);

		if($_POST['original_post_status'] == 'publish') 
		{
			$title = get_option('pb_update_prefix') . $title;
		}
		else
		{
			$title = get_option('pb_new_prefix') . $title;
		}

		$pb_url = "http://tinyurl.com/api-create.php?url=" . $postlink;
		$url_contents = file_get_contents($pb_url);

		$temp_length = (strlen($title)) + (strlen($url_contents));

		if($temp_length > 137) 
		{
			$remaining_chars = 134 - strlen($url_contents);
			$title = substr($title, 0, $remaining_chars);
			$title = $title . "...";
		}

		$message = $title . " - " . $url_contents;

		// Plurk API
			
		$api_key = 'QEpYPQUSMLI4LJDzG6fSXzoRux9bzqYx';
		require('plurk_api.php');
	        $plurk = new plurk_api();
                $plurk->login($api_key, $username, $password);
		$plurk->addPlurk(en, says, $message, NULL, 0);

	}

}

function update_pb_meta($pid, $value)
{
	if (!update_post_meta($pid, 'pb_plurk', $value)) {
		add_post_meta($pid, 'pb_plurk', $value);
	}
}
